<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Log;

class SignAuthMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  \Closure $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        Log::info('签名--' . generateSign($request->all(),config('customer.app_secret')));
        try {
            if (!verifySign($request->get('sign'), $request->all(), config('customer.app_secret'))) {
                $error = [
                    'message' => '数据验签失败',
                    'code' => 401,
                ];
                return response()->json($error)->setStatusCode(401);
            }

        } catch (\Exception $e) {
            $error = [
                'message' => $e->getMessage(),
                'code' => 401,
            ];
            return response()->json($error)->setStatusCode(401);
        }
        return $next($request);
    }
}
