<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/6/15
 * Time: 17:08
 */
namespace  App\Transformers\Circle;

use App\Models\InterestCircleMessageComment;
use App\Models\PostComment;
use App\Traits\PostTrait;
use App\Traits\UserTrait;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;

class ReplyTransformer extends TransformerAbstract
{
    use UserTrait;

    public function transform(InterestCircleMessageComment $postComment)
    {
        $user = $this->userInfo($postComment['uid']);
        $replyUsername = '';
        if($postComment['reply_uid']){
            $userReply = $this->userInfo($postComment['reply_uid']);
            $replyUsername = $userReply['username'];
        }
        return [
            'id' => $postComment['id'],
            'uid' => $postComment['uid'],
            'username' => $user['username'],
            'reply_username' => $replyUsername,
            'avatar' => $user['avatar'],
            'content' => $postComment['is_delete']?'该回复已被删除':$postComment['content'],
            'created_at' => Carbon::parse($postComment['created_at'])->diffForHumans(),
            'is_delete' => $postComment['is_delete']
        ];
    }
}